

(*
 * weirdWrap : 'a -> bool -> 'a list
 * REQUIRES: true
 * ENSURES: weirdWrap x true ==> [x]
 *  and weirdWrap x false ==> [x,x]
 *)
fun weirdWrap (x:'a) (b:bool) : 'a list = 
  let 
    exception X of 'a (* a polymorphic exception *)
  in
    (
      if b 
      then [x]
      else (raise X x)
    )
    handle X y => [y,y]
  end 






